# STM32L073Z-EVAL Evaluation board

## Overview

The STM32L073Z-EVAL Evaluation board is designed as a complete demonstration and development platform for the STMicroelectronics Arm® Cortex®-M0+ core-based STM32L073VZT6 microcontroller with three I2Cs, two SPIs, four USARTs, one UART, one 12-bit ADC, two 12-bit DACs, LCD driver, up to 192-Kbyte flash memory, 20-Kbyte RAM, 6-Kbyte EEPROM, touch sensing, USB FS, LCD controller, SWD debugging support. This Evaluation board can be used as a reference design for user application development but is not considered as a final application.

The full range of hardware features on the board helps the user to evaluate all peripherals (USB FS, RS-232, USART, 12-bit ADC and DAC, color TFT LCD, LCD segments, low-power UART, IrDA, microSD™ card, touch-sensing slider, pressure measurement, temperature measurement, LC sensor metering) and to develop applications. The extension headers offer the possibility to connect a daughterboard or a wrapping board for a specific application.

An embedded ST-LINK/V2-1 debugger facilitates the software development and the programming of the STM32L073VZT6 microcontroller.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1878-evaluation-board-with-stm32l073vz-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32L073VZ microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32l073vz.html)
- [STM32L073Z-EVAL board](https://www.st.com/en/evaluation-tools/stm32l073z-eval.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1878-evaluation-board-with-stm32l073vz-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32l073z-eval.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1168-l073vzt6-c02-schematic.pdf)
